package net.eclipseforum.verysimpleblog;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet implementation class for Servlet: BlogListServlet
 * 
 */
public class BlogListServlet extends BlogServlet implements
		javax.servlet.Servlet {
	static final long serialVersionUID = 1L;

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	public BlogListServlet() {
		super();
	}

	/*
	 * (non-Java-doc)
	 * 
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request,
	 *      HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		Connection conn = null;
		ResultSet rs = null;
		Statement stmt = null;

		try {
			conn = getConnection();

			stmt = conn.createStatement();
			stmt
					.execute("SELECT * FROM articles a ORDER BY a.posteddate DESC, a.postedtime DESC");
			rs = stmt.getResultSet();

			HttpSession session = request.getSession();
			Vector<BlogPostBean> list = new Vector<BlogPostBean>();

			while (rs.next()) {
				SimpleDateFormat sdf = new SimpleDateFormat(
						"yyyy-MM-dd HH:mm:ss");

				Date postedDateTime = null;
				try {
					postedDateTime = sdf.parse(rs.getDate("posteddate") + " "
							+ rs.getTime("postedtime"));
				} catch (ParseException e) {
					e.printStackTrace();
				}

				list.add(new BlogPostBean(rs.getString("title"), rs
						.getString("content"), postedDateTime));
			}

			conn.commit();

			session.setAttribute("list", list);
			String url = "/list.jsp";
			ServletContext sc = getServletContext();
			RequestDispatcher rd = sc.getRequestDispatcher(url);
			rd.forward(request, response);

		} catch (ClassNotFoundException cnfe) {
			System.err.println("Derby driver not found.");
		} catch (SQLException ex) {
			try {
				conn.rollback();
			} catch (Exception e) {
			}
			ex.printStackTrace();
		} finally {
			try {
				rs.close();
			} catch (SQLException e) {
			}
			try {
				stmt.close();
			} catch (SQLException e) {
			}
			try {
				releaseConnection(conn);
			} catch (SQLException e) {
			}
		}
	}
}